package com.engine.attendance.attendanceanalysis.cmd;

import com.engine.attendance.enums.SystemItemEnum;
import com.engine.common.biz.AbstractCommonCommand;
import com.engine.common.entity.BizLogContext;
import com.engine.common.util.DbTools;
import com.engine.core.interceptor.CommandContext;
import com.google.common.collect.Maps;
import weaver.conn.RecordSet;
import weaver.general.Util;

import java.util.List;
import java.util.Map;

/**
 * 更新人员当天出勤结果
 */
public class UpdateAttendanceResultsCmd extends AbstractCommonCommand<Map<String,Object>> {


    @Override
    public BizLogContext getLogContext() {
        return null;
    }
    public UpdateAttendanceResultsCmd(Map<String,Object> params){
        this.params=params;
    }

    @Override
    public Map<String, Object> execute(CommandContext commandContext) {
        String userId = Util.null2String(params.get("userId"));
        String date = Util.null2String(params.get("date"));
        //项目
        String item = Util.null2String(params.get("item"));
        //项目时长
        String itemduration = Util.null2String(params.get("itemduration"));
        Map<String,Object> resultMap = Maps.newHashMap();
        RecordSet rs = new RecordSet();
        //班次信息
        if (params.get("classInfo") == null){
            //当天没有排班，计入异常
            noScheduling(params,rs);
            return resultMap;
        }
        List<Map<String,Object>> classInfo = (List<Map<String,Object>>)params.get("classInfo");

        String sql = "select ygid,rq,bc,xm1,xm2,xm3,xm4,xm5,xm6,xm7,xm8,j1,c1,j2,c2,j3,c3,j4,c4,j5,c5,j6,c6,j7,c7,j8,c8 from uf_jcl_kq_cqjg where ygid=? and rq=?";
        List<Map<String,Object>> dataList = DbTools.getSqlToList(sql,userId,date);
        if (dataList.size() >0){
            //有出勤结果
            int index = 0;
            int i = 0;
            while (index==0){
                i++;
                if (dataList.get(0).get("xm"+i) != null || !"".equals(dataList.get(0).get("xm"+i))){
                    index = i;
                }
            }
            sql = "update uf_jcl_kq_cqjg set xm"+index+"=?,sc"+index+"=? where ygid=? and rq=?";
            DbTools.update(rs,sql,item,itemduration,userId,date);

        }else {
            //没有出勤结果
            sql = "select subcompanyid1,departmentid,jobtitle from hrmresource  where id=?";
            List<Map<String,Object>> userList = DbTools.getSqlToList(sql,userId);
            sql = "insert into uf_jcl_kq_cqjg (szjg,ygid,fbid,bm,zw,rq,bc,bcbdxx,cqzt,cqsc,xm1,sc1) values (?,?,?,?,?,?,?,?,?,?,?,?)";
            DbTools.update(rs,sql,userList.get(0).get("subcompanyid1"),userId,userList.get(0).get("subcompanyid1"),userList.get(0).get("departmentid"),
                    userList.get(0).get("jobtitle"),date,classInfo.get(0).get("bcxx"),classInfo.get(0).get("bcsdxx"),1,0,item,itemduration);


        }

        return resultMap;
    }

    /**
     * 没有排班处理
     * @param params
     */
    public void noScheduling(Map<String,Object> params, RecordSet rs){
        String userId = Util.null2String(params.get("userId"));
        String date = Util.null2String(params.get("date"));
        String sql = "select subcompanyid1,departmentid,jobtitle from hrmresource  where id=?";
        List<Map<String,Object>> userList = DbTools.getSqlToList(sql,userId);
        sql = "insert into uf_jcl_kq_cqjg (szjg,ygid,fbid,bm,zw,rq,xm1,cqzt) values (?,?,?,?,?,?,?,?)";
        DbTools.update(rs,sql,userList.get(0).get("subcompanyid1"),userId,userList.get(0).get("subcompanyid1"),
                userList.get(0).get("departmentid"),userList.get(0).get("jobtitle"),date, SystemItemEnum.NO_SCHEDULING.getKey(),1);


    }
}
