package com.engine.attendance.attendanceanalysis.job;


import com.engine.attendance.attendanceanalysis.wrapper.AttendanceAnalysisWrapper;
import com.engine.attendance.workflow.service.ProcessSubmitCheckService;
import com.engine.attendance.workflow.service.impl.ProcessSubmitCheckServiceImpl;
import com.engine.common.util.DateUtil;
import com.engine.common.util.DbTools;
import com.engine.common.util.ServiceUtil;
import lombok.extern.slf4j.Slf4j;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.interfaces.schedule.BaseCronJob;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Slf4j
public class AttendanceAnalysisJob extends BaseCronJob {


    private AttendanceAnalysisWrapper attendanceAnalysisService = ServiceUtil.getService(AttendanceAnalysisWrapper.class);
    @Override
    public void execute() {
        log.info("********AttendanceAnalysisJob  start********");
        String beforeThreeDayDate = DateUtil.getCurrentDateMinusDay(3);
        String beforeOneDayDate = DateUtil.getCurrentDateMinusDay(1);
        String sql = "select id,userid,signdate,signtime from hrmschedulesign where isincom=1 and signdate >= ? and signdate <= ?";

        List<Map<String,Object>> dataList = DbTools.getSqlToList(sql,beforeThreeDayDate,beforeOneDayDate);

        Map<String, List<Map<String,Object>>> collect = dataList.stream().collect(Collectors.groupingBy(e -> Util.null2String(e.get("userid"))));
        collect.entrySet().forEach(e -> {
            attendanceAnalysisService.attendanceAnalysis(e.getKey(),e.getValue());
        });
        log.info("********AttendanceAnalysisJob  end********");
    }
}
